//przykladowa implementacja mergesort'u
//mergesort'u bez rekursji a z wykorzystaniem stosu

#include<cstdio>
#include<cstdlib>
#include<iostream>
#include<iomanip>

using namespace std;

//etykiety odpowiadajace miejscom w kodzie 
//rekurencyjnego mergesort
enum Labels {l_start, l_middle, l_end};

//definicja stosu
typedef
struct StackElem{
	int beg;
	int end;
	Labels lab;
	StackElem* next;
}StackElem;

StackElem* stack=NULL;

int empty(){
	return(stack==NULL);;
}

void push(int x, int y, Labels l){
	StackElem* ptr=new(StackElem);
	ptr->beg=x;
	ptr->end=y;
	ptr->lab=l;
	ptr->next=stack;
	stack=ptr;
}

StackElem pop(){
	StackElem tmp=(*stack);
	StackElem* ptr=stack;
	stack=stack->next;
	delete(ptr);
	return tmp;
}


const int maxsize = 9;

int t[maxsize]={7,3,4,5,1,4,9,8,13};
int pom[maxsize];

void swap(int *t, int i, int j){
	int pom=t[i];
     t[i]=t[j];
	t[j]=pom;
}

void printing(int *t, int size){
	cout<<endl;
	for(int i=0;i<size;i++)
	cout<<t[i]<<", ";
}


void merge(int*, int, int);
void mergesort(int*, int, int);
void mergesort_norec(int*, int, int size);

int main(void){
    for(int i=0;i<maxsize;i++)
	         	cout<<t[i]<<", ";
	cout<<endl<<flush;
    mergesort_norec(t,0,maxsize);
	cout<<endl;
	for(int i=0;i<maxsize;i++)
		cout<<t[i]<<", ";
	cout<<endl<<flush;
	system("read -p \"Press [Enter]\" "); //Linux
	//system("pause"); //DOS
	return 1;
} //main



void merge(int* t, int lewy, int polowa, int prawy){
int i=lewy;
int j=polowa;
int m=i;
while(i<polowa && j<prawy){
    if(t[i]<t[j]){
       pom[m]=t[i];
       i++; m++;
    }
    else{
       pom[m]=t[j];
        j++;m++;
   }
}
if(i==polowa)
  while(j<prawy){
      pom[m]=t[j]; m++; j++;
   }
 else
   while(i<polowa){
       pom[m]=t[i];m++;i++;
    }        
for(int k=lewy;k<prawy;k++)
   t[k]=pom[k];
}

//sortuje tablice t[lewy, prawy-1]
void mergesort(int* t, int lewy, int prawy){
	label_start:
     cout<<endl<<"ms("<<lewy<<", "<<prawy<<"), [";
     for(int i=0;i<maxsize;i++) cout<<t[i]<<", ";
     cout<<endl;
	 if(lewy+1>=prawy){
		 cout<<"Koniec wywolania mergesort("<<lewy<<", "<<prawy<<")"<<endl;
         return;
	 }
     int polowa=lewy + (prawy-lewy)/2;
     mergesort(t,lewy,polowa);
	 label_mid:
     mergesort(t,polowa,prawy);
	 label_ending:
     merge(t,lewy,polowa,prawy);
	 cout<<"Koniec wywolania mergesort("<<lewy<<", "<<prawy<<")"<<endl;
} 

//sortuje tablice t[lewy,prawy-1]
//rekurencje zastepuje odkladaniem zadan na stosie,
//poszczegolne przypadki w instrukcji switch(tmp.lab)
//odpowiadają różnym etykietom w kodzie funkcji mergesort powyżej  
void mergesort_norec(int* t, int lewy, int prawy){
	if(!empty())
		return;
	push(lewy,prawy,l_start);
	while(!empty()){
		StackElem tmp=pop();
		int mid=tmp.beg+(tmp.end - tmp.beg)/2;
		switch(tmp.lab){
			case l_start:
				if(tmp.beg+1>=tmp.end) break;
				push(tmp.beg,tmp.end,l_middle);
				push(tmp.beg,mid,l_start);
				break;
			case l_middle:
				push(tmp.beg,tmp.end,l_end);
				push(mid,tmp.end,l_start);
				break;
			case l_end:
				merge(t,tmp.beg,mid,tmp.end);
				break;
		}
	}
}

